-- forageWagonAddon

-- Datum: 09.10.2014
-- Autor: Ifko[nator]
-- Version 1.0

forageWagonAddon = {};

function forageWagonAddon.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(ForageWagon, specializations);
end;

function forageWagonAddon:load(xmlFile)
	--[[self.isFilling = false;
	self.previousLevel = self.fillLevel;]]
	self.saveMinimumRpm = 0;
	self.isTipping = false;
	
	self.transportBase = {};
	self.transportBase.node = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.transportBase#index"));
	self.transportBase.unloadingSpeed = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.transportBase#unloadingSpeed"), 0.001);
	self.transportBase.loadingSpeed = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.transportBase#loadingSpeed"), 0.0005);
	self.transportBase.speed = self.transportBase.loadingSpeed;
	self.transportBase.unloadingDirection = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.transportBase#unloadingDirection"), 1);
	setShaderParameter(self.transportBase.node, "movingDirection", 0, 0, 0, 0, false);
	
	self.dosingRolls = {};
	self.dosingRolls.object = {};
	self.dosingRolls.speed = {};
	
	local i = 1;
	while true do 
		local dosingRoll = Utils.indexToObject(self.components, getXMLString(xmlFile, string.format("vehicle.dosingRolls#dosingRoll%d", i)));
		if dosingRoll == nil then
			break;
		end;
		self.dosingRolls.object[i] = dosingRoll;
		self.dosingRolls.speed[i] = 0;
		i = i + 1;
	end;
	
	self.pickupZinken = {};
	self.pickupZinken.object = {};
	self.pickupZinken.speed = {};
	
	local k = 1;
	while true do 
		local pickupZinke = Utils.indexToObject(self.components, getXMLString(xmlFile, string.format("vehicle.pickupZinken#pickupZinke%d", k)));
		if pickupZinke == nil then
			break;
		end;
		self.pickupZinken.object[k] = pickupZinke;
		self.pickupZinken.speed[k] = 0;
		k = k + 1;
	end;
end;

function forageWagonAddon:delete()
end;

function forageWagonAddon:mouseEvent(posX, posY, isDown, isUp, button)
end;

function forageWagonAddon:keyEvent(unicode, sym, modifier, isDown)
end;

function forageWagonAddon:updateTick(dt)
	if self:getIsActive() then
		if self.isTurnedOn then
			--[[if self.previousLevel ~= self.fillLevel then
				if self.previousLevel < self.fillLevel then
					self.isFilling = true;
				else
					self.isFilling = false;
				end;
				self.previousLevel = self.fillLevel;
			end;]]
			for k, j in pairs(self.pickupZinken.object) do
				local rX, rY, rZ = getRotation(j);
				self.pickupZinken.speed[k] = self.pickupZinken.speed[k] + 0.002 + math.random()/200;
				self.pickupZinken.speed[k] = math.min(self.pickupZinken.speed[k], 0.25);
				if k == 2 then
					rX = rX - self.pickupZinken.speed[k];
				else
					rX = rX + self.pickupZinken.speed[k];
				end;
				setRotation(j, rX, rY, rZ);
			end;
		else
			--self.isFilling = false;
			for k, j in pairs(self.pickupZinken.object) do
				local rX, rY, rZ = getRotation(j);
				self.pickupZinken.speed[k] = self.pickupZinken.speed[k] - 0.0002 - math.random()/200;
				self.pickupZinken.speed[k] = math.max(self.pickupZinken.speed[k], 0.0);
				if k == 2 then
					rX = rX - self.pickupZinken.speed[k];
				else
					rX = rX + self.pickupZinken.speed[k];
				end;
				setRotation(j, rX, rY, rZ);
			end;
		end;
		if self.fillLevel >= self.capacity then
			if not self.isTipping then
				self:setIsTurnedOn(false);
			end;
		end;
		if self.isTipping then
			for i, j in pairs(self.dosingRolls.object) do
				local rX, rY, rZ = getRotation(j);
				self.dosingRolls.speed[i] = self.dosingRolls.speed[i] + 0.004 + math.random()/200;
				self.dosingRolls.speed[i] = math.min(self.dosingRolls.speed[i], 0.6);
				if i == 2 then
					rX = rX - self.dosingRolls.speed[i];
				else
					rX = rX + self.dosingRolls.speed[i];
				end;
				setRotation(j, rX, rY, rZ);
			end;
		else
			for i, j in pairs(self.dosingRolls.object) do
				local rX, rY, rZ = getRotation(j);
				self.dosingRolls.speed[i] = self.dosingRolls.speed[i] - 0.0005 - math.random()/200;
				self.dosingRolls.speed[i] = math.max(self.dosingRolls.speed[i], 0.0);
				if i == 2 then
					rX = rX - self.dosingRolls.speed[i];
				else
					rX = rX + self.dosingRolls.speed[i];
				end;
				setRotation(j, rX, rY, rZ);
			end;
		end;
	end;
end;

function forageWagonAddon:update(dt)
	if self.attacherVehicle ~= nil and self.attacherVehicle.motor ~= nil then
		if self.isTurnedOn then
			--if self.isFilling then
				self.attacherVehicle.motor.minRpm = math.max(self.attacherVehicle.motor.minRpm-(dt * 2), - 800);
				--[[print("Increase filling = 800");
			else
				self.attacherVehicle.motor.minRpm = math.max(self.attacherVehicle.motor.minRpm-(dt * 2), - 200);
				print("Increase not filling = 200");
			end;]]
		else
			self.attacherVehicle.motor.minRpm = self.saveMinimumRpm;
		end;
	end;
end;

function forageWagonAddon:onAttach(attacherVehicle)
	self.attacherVehicle = attacherVehicle;
	if self.attacherVehicleCopy1 == nil then
		self.attacherVehicleCopy1 = self.attacherVehicle;
	end;
	if self.attacherVehicle.motor ~= nil then
		self.saveMinimumRpm = self.attacherVehicle.motor.minRpm;
	else
		if self.attacherVehicle.saveMinRpm ~= nil then
			self.saveMinimumRpm = self.attacherVehicle.saveMinimumRpm;
		else
			self.attacherVehicle.saveMinimumRpm = 100;
		end;
	end;
end;

function forageWagonAddon:onDetach()
	for k, steerable in pairs(g_currentMission.steerables) do
		if self.attacherVehicleCopy1 == steerable then
			steerable.motor.minRpm = self.saveMinimumRpm;
			self.attacherVehicleCopy1 = nil;
		end;
	end;
end;

function forageWagonAddon:onStartTip(currentTipTrigger, noEventSend)
	self:setIsTurnedOn(true);
	self.isTipping = true;
	setShaderParameter(self.transportBase.node, "movingDirection", self.transportBase.unloadingDirection * self.transportBase.unloadingSpeed, 0, 0, 0, false);
end;

function forageWagonAddon:onEndTip(noEventSend)
	self:setIsTurnedOn(false);
	self.isTipping = false;
	setShaderParameter(self.transportBase.node, "movingDirection", 0, 0, 0, 0, false);
end;

function forageWagonAddon:draw()
	if self.st == nil then
        g_currentMission:addWarning(g_i18n:getText("WARNING_SHADERTIPPING"), 0.018, 0.033);
    end;
end

function forageWagonAddon:setIsTurnedOn(turnedOn, noEventSend)
	SetTurnedOnEvent.sendEvent(self, turnedOn, noEventSend)
	self.isTurnedOn = turnedOn;
	if turnedOn then			
		setShaderParameter(self.transportBase.node, "movingDirection", self.transportBase.unloadingDirection * self.transportBase.loadingSpeed, 0, 0, 0,false);
	else
		setShaderParameter(self.transportBase.node, "movingDirection", 0, 0, 0, 0, false);
	end;	
end;